package de.cnc.domainparser;

import de.cnc.domainparser.util.SourcePosition;

public abstract class AbstractNonTerminalElement extends AbstractElement {

    // ----------------------------------------------------------------------

    /**
     * alle von AbstractNonTerminalElement erbenden Klassen
     * sind nicht terminal (komplex, besitzen Unter-Elemente)
     */
	public final boolean isTerminal() 
    {
		return false;
	}

    // ----------------------------------------------------------------------

    protected SourcePosition endSourcePosition;

    /**
     * @see de.cnc.domainparser.AbstractElement#getEndSourcePos()
     */
    public final SourcePosition getEndSourcePos() 
    {
        return this.endSourcePosition.getClone();
    }

	protected int length;

	/**
     * Lnge des von diesem non terminalen Element 
     * berdeckten Bereiches in Anzahl Zeichen
     * 
     * @return
     */
	public final int getLength() 
    {
	    return this.length;
	}



}
