package de.cnc.domainparser;

import de.cnc.domainparser.util.SourcePosition;

public abstract class AbstractTerminalElement extends AbstractElement 
{
	/**
     * alle von AbstractTerminalElement erbenden Klassen
     * sind terminal (einfach, keine Unter-Elemente)
	 */
	public final boolean isTerminal() 
    {
		return true;
	}


	public boolean isEmpty() 
    {
		return false;
	}

    /**
     * es sollte keine Kommentar-Unter-Elemente geben,
     * nichts zu tun.
     */
	public final void stripComments(boolean pAllComments) 
    {
        ;//nichts zu tun
        throw new UnsupportedOperationException();
	}

    /**
     * bei nicht terminalen Symbolen nicht untersttzt
     * 
     * @see de.cnc.domainparser.AbstractElement#getEndSourcePos()
     */
    public final SourcePosition getEndSourcePos() 
    {
        throw new UnsupportedOperationException("not supported for class " + this.getClass().getName() );
    }
}
