package de.cnc.domainparser;

import de.cnc.domainparser.demo.DomainParserDemo;


/**
 * Diese Klasse transportiert die optionalen Einstellung des
 * {@link DomainParserDemo} zu den einzelnen parse-Methoden
 * der Elemente
 */
public class DomainParserContext
{

    /**
     * 
     */
    public DomainParserContext()
    {
        super();
    }

    /** ob ein Punkt in Bezeichnern erlaubt ist */
    public boolean isPointInIdentifierAllowed = true;

    /** ob ein Doppel-Punkt in Bezeichnern erlaubt ist */
    public boolean isColonInIdentifierAllowed = true;

    /** ob die Java-blichen Encodings in Strings verwendet werden sollen */
    public boolean isJavaStringEncodingEnabled = false;

    /** ob die Java-blichen Encodings in Strings verwendet werden sollen */
    public boolean isNewlineInStringEnabled = false;

    /** System line.separator */
    public static final String lineSeparator = System.getProperty( "line.separator" );
    
   /**
    * returns an clone of this
    * @return an clone of this
    */
   public DomainParserContext getClone()
   {
      DomainParserContext clone = new DomainParserContext();
      clone.isPointInIdentifierAllowed = this.isPointInIdentifierAllowed;
      clone.isJavaStringEncodingEnabled = this.isJavaStringEncodingEnabled;
      return clone;      
   }
}
