package de.cnc.domainparser.demo;


import de.cnc.domainparser.DomainParseException;
import de.cnc.domainparser.DomainParserContext;
import de.cnc.domainparser.Unit;
import de.cnc.util.StringUtil;


/*
<pre>
- Package (mehrere Dateien in einem Verzeichnis, nicht fertig)
-   |
-   +- Unit (eine Datei)
-      |
-      +- Segment (eine Deklaration oder eine Klasse)
-      |
-      +- Element
-      |
-      +- Token (Wort, Zahl oder Operator)
-      |
-      +- ParenthesisArea (runde Klammern-Abschnitt)
-      |
-      +- BracketArea (eckige Klammern-Abschnitt)
-      |
-      +- BracesArea (geschwungene Klammern-Abschnitt)
</pre>
 statt Dateien knnen auch Strings oder Streams den SourceCode liefern

 */
public class DomainParserDemo
{

    public static final String SCRIPT_IN_FILE = "./src/de/cnc/domainparser/test.script";

    public static final String PROPERTIES_IN_FILE = "./src/de/cnc/domainparser/test.hierarchicproperties";

    public static void main(String[] args)
    {
        // String srcStr =
        // "Haus"+
        // "{"+
        // "  Etage"+
        // "  {"+
        // "    int iNr;" +
        // "    Wohnung"+
        // "    {"+
        // "    }"+
        // "  }"+
        // "}";
        //
        // Unit tUnit = Unit.parse( srcStr );

        // InputStream inpStream = String.class.getResourceAsStream( "test.def" );

        // int i = 0; // debug stop

        if (1 == 1)
        {
            System.out.println("---------------------------------------------------------");
            System.out.println("Test IN-FILE");

            String inputStr = StringUtil.file2str(SCRIPT_IN_FILE);

            System.out.println("inputStr:\n" + inputStr);

            DomainParserContext parserContext = new DomainParserContext();
            Unit tUnit = null;

            try
            {
                tUnit = Unit.parseFile(SCRIPT_IN_FILE, parserContext);
            }
            catch (DomainParseException e)
            {
                System.err.println(e.getMessage());
                e.printStackTrace();
            }
            System.out.println("---------------------------------------------------------");
            System.out.println("Test IN-FILE geparst");

            System.out.println("" + tUnit);

            System.out.println("---------------------------------------------------------");
            System.out.println("Test Beautifier");

            String beautiStr = Beautifier.format(tUnit);

            System.out.println(beautiStr);

            System.out.println("---------------------------------------------------------");

        }

        System.out.println("---------------------------------------------------------");
        System.out.println("Test hierarchic Properties");

        String inputStr = StringUtil.file2str(PROPERTIES_IN_FILE);

        System.out.println("inputStr:\n" + inputStr);

        System.out.println("---------------------------------------------------------");
        System.out.println("Test hierarchic Properties geparst");

        DomainParserContext parserContext = new DomainParserContext();
        Unit tUnit = null;

        try
        {
            tUnit = Unit.parseFile(PROPERTIES_IN_FILE, parserContext);
        }
        catch (DomainParseException e)
        {
            System.err.println(e.getMessage());
            e.printStackTrace();
        }
        System.out.println("---------------------------------------------------------");

        System.out.println("" + tUnit);

        System.out.println("---------------------------------------------------------");

        HierarchicProperties hierarchicProperties = null;

        try
        {
            hierarchicProperties = new HierarchicProperties(tUnit);
        }
        catch (DomainParseException e)
        {
            System.err.println(e.getMessage());
            e.printStackTrace();
        }
        System.out.println("" + hierarchicProperties);
        System.out.println("---------------------------------------------------------");
        System.out.println("Test hierarchic Properties Abfrage Werte");

        System.out.println("" + hierarchicProperties.getValue("c/c/c.c.b"));

        System.out.println("---------------------------------------------------------");

    }

}
