package de.cnc.domainparser.util;


public class DomainParserUtil
{

    /**
     * Anzahl weisse Zeichen an angegebener Position ermitteln.
     *
     * @param  paStr   zu parsender String
     * @param  pSrcPos SourcePosition, welche um die weissen Zeichen weitergerollt wird
     *                 (Achtung Seiteneffekt)
     * @return Anzahl weisser Zeichen
     */
    public static void parseWhitesAndComments(
            final String pStr,
            final SourcePosition pSrcPos)
    {
        // int anfPos = pSrcPos.getPos();

        // System.out.println("1|" + paStr + "|");
        while (pSrcPos.getPos() < pStr.length())
        {

            // System.out.println("pSrcPos " + pSrcPos);

            char cTmp = pStr.charAt(pSrcPos.getPos());

            // System.out.println("cTmp " + cTmp);

            if (cTmp == '\n') // NewLine
            {
                pSrcPos.addNewLine();
            }
            else if (cTmp != ' ' && // Space
                    cTmp != '\t' && // Tabulator
                    cTmp != '\r') // Dos-Return
            {
                // Ende der weissen Zeichen erreicht
                break;
            }
            else
            {
                pSrcPos.addOne();
            }
        }

        // System.out.println("2|" + paStr.substring(iRet) + "|");

        // if (pSrcPos.getPos() < pStr.length() && pStr.substring(pSrcPos.getPos()).startsWith("//")) {
        // pSrcPos.add(2);
        // while (pSrcPos.getPos() < pStr.length()) {
        // char cTmp = pStr.charAt(pSrcPos.getPos());
        //
        // if (cTmp == '\n') {
        // pSrcPos.addOne();
        // break;
        // }
        //
        // }
        // }    	
        // else if (pSrcPos.getPos() < pStr.length() && pStr.substring(pSrcPos.getPos()).startsWith("/*")) {
        // pSrcPos.add(2);
        // while (pSrcPos.getPos() < pStr.length()) {
        // if (pStr.substring(pSrcPos.getPos()).startsWith("*/")) {
        // pSrcPos.add(2);
        // break;
        // }
        //
        // }
        // }    	
        //
        // while (pSrcPos.getPos() < pStr.length()) {
        //
        // char cTmp = pStr.charAt(pSrcPos.getPos());
        //
        // if (cTmp == '\n') // NewLine
        // {
        // pSrcPos.addNewLine();
        // }
        // else if (cTmp != ' ' && // Space
        // cTmp != '\t' && // Tabulator
        // cTmp != '\r') // Dos-Return
        // {
        // // Ende der weissen Zeichen erreicht
        // break;
        // }
        // pSrcPos.addOne();
        // }
        // return pSrcPos.getPos() - anfPos;
    }// end method parseWhites

    /**
     * Ob das bergebene Zeichen ein weisses Zeichen ist
     * 
     * @param pChar
     * @return
     */
    public static boolean isWhite(char pChar)
    {
        return (pChar == ' ' || pChar == '\t' || pChar == '\n' || pChar == '\r');
    }

}
